Index: /trunk/src/check_files.m
===================================================================
--- /trunk/src/check_files.m	(revision 597)
+++ /trunk/src/check_files.m	(revision 598)
@@ -117,5 +117,4 @@
     'view_field.m';...% function for visualisation of projected fields'
     'view_field.fig';...%GUI for view_field
-    'write_plot_param';...%update plotting parameters after plot, TODO: change into a general function: fill_GUI
     'xml2struct';...% read an xml file as a Matlab structure, converts numeric character strings into numbers
     };
Index: /trunk/src/editxml.m
===================================================================
--- /trunk/src/editxml.m	(revision 597)
+++ /trunk/src/editxml.m	(revision 598)
@@ -345,16 +345,17 @@
         xs=xmltree(schemafile);
     else
-        msgbox_uvmat('WARNING','The xml schema is not found, check the file PARAM.xml')
-        [FileName, PathName]=uigetfile( ...
-            {'*.xsd', '(*.xsd)';
-            '*.xsd',  '.xsd files '; ...
-            '*.*',  'All Files (*.*)'}, ...
-            'Pick a .xsd schema' ,schemafile); %file browser
-        if ischar(PathName) && ischar(FileName) && exist(fullfile(PathName,FileName),'file')
-            DataIn.Schema=fullfile(PathName,FileName);
-            xs=xmltree(DataIn.Schema);%open the associated schema file
-        else
+%         msgbox_uvmat('WARNING','The xml schema is not found, check the file PARAM.xml')
+%         [FileName, PathName]=uigetfile( ...
+%             {'*.xsd', '(*.xsd)';
+%             '*.xsd',  '.xsd files '; ...
+%             '*.*',  'All Files (*.*)'}, ...
+%             'Pick a .xsd schema' ,schemafile); %file browser
+%         if ischar(PathName) && ischar(FileName) && exist(fullfile(PathName,FileName),'file')
+%             DataIn.Schema=fullfile(PathName,FileName);
+%             xs=xmltree(DataIn.Schema);%open the associated schema file
+%         else
             xs=[];
-        end
+% 
+
     end
     %         end
Index: /trunk/src/fill_GUI.m
===================================================================
--- /trunk/src/fill_GUI.m	(revision 597)
+++ /trunk/src/fill_GUI.m	(revision 598)
@@ -14,5 +14,9 @@
 %------------------------------------------------------------------------
 errormsg='';
-handles=guidata(GUI_handle); 
+%handles=guidata(GUI_handle); 
+            children=get(GUI_handle,'children');
+            for ichild=1:numel(children)
+                handles.(get(children(ichild),'tag'))=children(ichild);
+            end
 UserData=get(GUI_handle,'UserData');
 fields=fieldnames(Param);%list of fields in Param
Index: /trunk/src/series.m
===================================================================
--- /trunk/src/series.m	(revision 597)
+++ /trunk/src/series.m	(revision 598)
@@ -70,5 +70,5 @@
 set(hObject,'Units','pixels')
 set(handles.PairString,'ColumnName',{'pairs'})
-set(handles.PairString,'ColumnEditable',logical(0))
+set(handles.PairString,'ColumnEditable',false)
 set(handles.PairString,'ColumnFormat',{'char'})
 set(handles.PairString,'Data',{''})
@@ -84,7 +84,7 @@
 [path_series,name,ext]=fileparts(which('series'));% path to the GUI series
 path_series_fct=fullfile(path_series,'series');%path of the functions in subdirectroy 'series'
-path_bin=fullfile(path_series,'bin');%path of the binary functions (compiled)
+%path_bin=fullfile(path_series,'bin');%path of the binary functions (compiled)
 ActionPathList=regexprep(ActionList,'^.+$',path_series_fct);% set path=path_series to each function in the list ('^.+$'=any non empty nbre of char form beginning to end of char string)
-ActionPathList=[ActionPathList regexprep(ActionList,'^.+$',path_bin)];% set path to compiled functions
+ActionPathList=[ActionPathList ActionPathList];% set path to .sh commands for compiled functions
 ActionExtList={'.m';'.sh'};% default choice of extensions (Matlab fct .m or compiled version .sh)
 RunModeList={'local';'background'};% default choice of extensions (Matlab fct .m or compiled version .sh)
@@ -1366,5 +1366,5 @@
     if exist(xmlfile,'file')
         s=xml2struct(xmlfile);
-        if strcmp(RunMode,'cluster') && isfield(s,'BatchParam')
+        if strcmp(RunMode,'cluster_oar') && isfield(s,'BatchParam')
             if isfield(s.BatchParam,'RunTime')
                 RunTime=s.BatchParam.RunTime;
@@ -1382,9 +1382,9 @@
         end
     end
-    if isempty(RunTime) && strcmp(RunMode,'cluster')
+    if isempty(RunTime) && strcmp(RunMode,'cluster_oar')
         msgbox_uvmat('ERROR','RunTime name not found in PARAM.xml, compiled version .sh cannot run on cluster')
         return
     end
-    Series.RunTime=RunTime;
+%     Series.RunTime=RunTime;
 end
 
@@ -1442,5 +1442,8 @@
         if isempty(Series.IndexRange.NbSlice)
             Series.IndexRange.first_i=first_i+(iprocess-1)*BlockLength;
-            Series.IndexRange.last_i=first_i+(iprocess)*BlockLength-1;
+            if Series.IndexRange.first_i>last_i
+                break
+            end
+            Series.IndexRange.last_i=min(first_i+(iprocess)*BlockLength-1,last_i);
         else
             Series.IndexRange.first_i= first_i+iprocess-1;
@@ -1459,7 +1462,7 @@
                     case {'PCWIN','PCWIN64'} %Windows system
                         filexml=regexprep(filexml,'\\','\\\\');% add '\' so that '\' are left as characters
-                        system([fullfile(ActionPath,[ActionName '.sh']) ' ' Series.RunTime ' ' filexml]);% TODO: adapt to DOS system
+                        system([fullfile(ActionPath,[ActionName '.sh']) ' ' RunTime ' ' filexml]);% TODO: adapt to DOS system
                     case {'GLNX86','GLNXA64','MACI64'}%Linux  system
-                        system([fullfile(ActionPath,[ActionName '.sh']) ' ' Series.RunTime ' ' filexml]);
+                        system([fullfile(ActionPath,[ActionName '.sh']) ' ' RunTime ' ' filexml]);
                 end
         end
@@ -1492,5 +1495,9 @@
         if isempty(Series.IndexRange.NbSlice)% process by blocks of i index
             Series.IndexRange.first_i=first_i+(iprocess-1)*BlockLength;
-            Series.IndexRange.last_i=first_i+(iprocess)*BlockLength-1;
+            if Series.IndexRange.first_i>last_i
+                NbProcess=iprocess-1;
+                break% leave the loop, we are at the end of the calculation
+            end
+            Series.IndexRange.last_i=min(last_i,first_i+(iprocess)*BlockLength-1);
         else% process by slices of i index if NbSlice is defined, computation in a single process if NbSlice =1
             Series.IndexRange.first_i= first_i+iprocess-1;
@@ -1506,6 +1513,8 @@
         
         %create the executable file
-        filebat=fullfile_uvmat(DirBat,'',Series.InputTable{1,3},'.bat',OutputNomType,...
-            Series.IndexRange.first_i,Series.IndexRange.last_i,first_j,last_j);
+%         filebat=fullfile_uvmat(DirBat,'',Series.InputTable{1,3},'.bat',OutputNomType,...
+%             Series.IndexRange.first_i,Series.IndexRange.last_i,first_j,last_j);
+         filebat=fullfile_uvmat(DirBat,'',Series.InputTable{1,3},'.sh',OutputNomType,...
+           Series.IndexRange.first_i,Series.IndexRange.last_i,first_j,last_j);
         batch_file_list{iprocess}=filebat;
         [fid,message]=fopen(filebat,'w');% create the executable file
@@ -1551,5 +1560,5 @@
                             'hostname && date \n '...
                             'umask 002 \n'...
-                            fullfile(ActionPath,[ActionName '.sh']) ' ' Series.RunTime ' ' filexml];%allow writting access to created files for user group
+                            fullfile(ActionPath,[ActionName '.sh']) ' ' RunTime ' ' filexml];%allow writting access to created files for user group
                         fprintf(fid,cmd);%fill the executable file with the  char string cmd
                         fclose(fid);% close the executable file
@@ -1590,5 +1599,5 @@
         fid=fopen(filename_joblist,'w');
         for p=1:length(batch_file_list)
-            fprintf(fid,[batch_file_list{p} '\n']);% list of exe files (TODO: create them)
+            fprintf(fid,[batch_file_list{p} '\n']);% list of exe files 
         end
         fclose(fid);
@@ -1705,6 +1714,6 @@
 end
 Series.IndexRange=rmfield(Series.IndexRange,'TimeTable');
-Series.IndexRange=rmfield(Series.IndexRange,'MinIndex');
-Series.IndexRange=rmfield(Series.IndexRange,'MaxIndex');
+% Series.IndexRange=rmfield(Series.IndexRange,'MinIndex');
+% Series.IndexRange=rmfield(Series.IndexRange,'MaxIndex');
 empty_line=false(size(Series.InputTable,1),1);
 for iline=1:size(Series.InputTable,1)
@@ -1726,4 +1735,6 @@
     end
 end
+set(handles.ActionName,'BackgroundColor',[1 1 0])
+drawnow
 
 %% get Action name and path
@@ -1752,5 +1763,6 @@
     end
     [ActionPath,ActionName,ActionExt]=fileparts(FileName);
-    % insert the choice in the menu
+    
+    % insert the choice in the menu ActionName
     ActionIndex=find(strcmp(ActionName,ActionList),1);% look for the selected function in the menu Action
     if isempty(ActionIndex)%the input string does not exist in the menu
@@ -1759,34 +1771,34 @@
         set(handles.ActionName,'String',ActionList)
     end
-    %set(handles.ActionName,'Value',ActionIndex)
-    %list_path{ActionIndex}=PathName;
+    
+    % record the file extension and extend the path list if it is a new extension
+    ActionExtList=get(handles.ActionExt,'String');
+    ActionExtIndex=find(strcmp(ActionExt,ActionExtList), 1);
+    if isempty(ActionExtIndex)
+        set(handles.ActionExt,'String',[ActionExtList;{ActionExt}])
+        ActionExtIndex=numel(ActionExtList)+1;
+        ActionPathNew=cell(size(ActionPathList,1),1);%new column of ActionPath
+        ActionPathList=[ActionPathList ActionPathNew];
+    end
+    set(handles.ActionName,'UserData',ActionPathList);
+
     % remove old Action options in the menu (keeping a menu length <nb_builtin_ACTION+5)
     if length(ActionList)>nb_builtin_ACTION+5; %nb_builtin=nbre of functions always remaining in the initial menu
         nbremove=length(ActionList)-nb_builtin_ACTION-5;
         ActionList(nb_builtin_ACTION+1:end-5)=[];
-        ActionPathList(nb_builtin_ACTION+1:end-4)=[];
+        ActionPathList(nb_builtin_ACTION+1:end-4,:)=[];
         ActionIndex=ActionIndex-nbremove;
     end
+    
+    % record action menu, choice and path
     set(handles.ActionName,'Value',ActionIndex)
     set(handles.ActionName,'String',ActionList)
-    ActionPathList{ActionIndex}=PathName;
-    set(handles.ActionPath,'enable','inactive')% indicate that the current path is accessible (not 'off')
-    
-    % record the file extension and update the paths in userdata
-    ActionExtList=get(handles.ActionExt,'String');
-    ActionExtIndex=find(strcmp(ActionExt,ActionExtList), 1);
-    if isempty(ActionExtIndex)
-        set(handles.ActionExt,'String',[ActionExtList;{ActionExt}])
-        set(handles.ActionExt,'Value',numel(ActionExtList)+1)
-        ActionPathNew=cell(size(ActionPathList,1),1);%new column of ActionPath
-        ActionPathNew{ActionIndex}=ActionPath;
-        ActionPathList=[ActionPathList ActionPathNew];
-    end
-    set(handles.ActionName,'UserData',ActionPathList);
-    
-    %record the current menu in personal file profil_perso
+    set(handles.ActionExt,'Value',ActionExtIndex)
+    ActionPathList{ActionIndex,ActionExtIndex}=PathName;
+        
+    %record the user defined menu additions in personal file profil_perso
     dir_perso=prefdir;
     profil_perso=fullfile(dir_perso,'uvmat_perso.mat');
-    if nb_builtin_ACTION+1<=length(ActionList)-1
+    if nb_builtin_ACTION+1<=numel(ActionList)-1
         ActionListUser=ActionList(nb_builtin_ACTION+1:numel(ActionList)-1);
         ActionPathListUser=ActionPathList(nb_builtin_ACTION+1:numel(ActionList)-1,:);
@@ -1811,9 +1823,9 @@
 
 %% default setting for the visibility of the GUI elements
-set(handles.FieldTransform,'Visible','off')
-set(handles.CheckObject,'Visible','off');
-set(handles.ProjObject,'Visible','off');
-set(handles.CheckMask,'Visible','off')
-set(handles.Mask,'Visible','off')
+% set(handles.FieldTransform,'Visible','off')
+% set(handles.CheckObject,'Visible','off');
+% set(handles.ProjObject,'Visible','off');
+% set(handles.CheckMask,'Visible','off')
+% set(handles.Mask,'Visible','off')
 
 %% create the function handle for Action
@@ -1834,6 +1846,6 @@
 end
 
-%% prepare the input param
-[Series,tild,errormsg]=prepare_jobs(handles);
+%% Activate the Action fct
+[Series,tild,errormsg]=prepare_jobs(handles);% read the parameters from the GUI series
 if ~isempty(errormsg)
     msgbox_uvmat('ERROR',errormsg)
@@ -1842,5 +1854,5 @@
 ParamOut=h_fun(Series);
 
-%% Put the first line of the selected Action fct as tootip help
+%% Put the first line of the selected Action fct as tooltip help
 try
     [fid,errormsg] =fopen([ActionName '.m']);
@@ -1849,8 +1861,4 @@
     set(handles.ActionName,'ToolTipString',InputText{1}{1})% put the first line of the selected function as tooltip help
 end
-% if ~isequal(path_series,PathName)
-%     rmpath(PathName)
-% end
-Param_list={};
 
 %% Detect the types of input files
@@ -1998,9 +2006,13 @@
     set(handles.ActionInput,'Visible','on')
     set(handles.ActionInput_title,'Visible','on')
+    set(handles.ActionInputView,'Visible','on')
+    set(handles.ActionInputView,'Value',0)
     set(handles.ActionInput,'String',ActionName)
+    ParamOut.ActionInput.Program=ActionName; % record the program in ActionInput
     SeriesData.ActionInput=ParamOut.ActionInput;
 else
     set(handles.ActionInput,'Visible','off')
     set(handles.ActionInput_title,'Visible','off')
+    set(handles.ActionInputView,'Visible','off')
     if isfield(SeriesData,'ActionInput')
     SeriesData=rmfield(SeriesData,'ActionInput');
@@ -2008,4 +2020,13 @@
 end   
 set(handles.series,'UserData',SeriesData)
+set(handles.ActionName,'BackgroundColor',[1 1 1])
+
+%------------------------------------------------------------------------
+% --- Executes on button press in ActionInputView.
+function ActionInputView_Callback(hObject, eventdata, handles)
+%------------------------------------------------------------------------
+if get(handles.ActionInputView,'Value')
+ActionName_Callback(hObject, eventdata, handles)
+end
 
 %------------------------------------------------------------------------
@@ -2427,4 +2448,6 @@
     if strcmp(FileType,'txt')
         edit(FullSelectName)
+    elseif strcmp(FileType,'xml')
+        editxml(FullSelectName)
     else
         uvmat(FullSelectName)
@@ -2606,2 +2629,4 @@
 NbSlice=str2num(get(handles.num_NbSlice,'String'));
 set(handles.num_NbProcess,'String',num2str(NbSlice))
+
+
Index: /trunk/src/series/aver_stat.m
===================================================================
--- /trunk/src/series/aver_stat.m	(revision 597)
+++ /trunk/src/series/aver_stat.m	(revision 598)
@@ -166,157 +166,156 @@
 end
 
-%% MAIN LOOP ON SLICES
 % for i_slice=1:NbSlice
-   % index_slice=i_slice:NbSlice:nbfield;% select file indices of the slice
-    nbfiles=0;
-    nbmissing=0;
-
-    %%%%%%%%%%%%%%%% loop on field indices %%%%%%%%%%%%%%%%
-    for index=1:nbfield
-    %for index=index_slice
-          if checkrun
-                stopstate=get(Param.RUNHandle,'BusyAction');
-                update_waitbar(Param.WaitbarHandle,index/nbfield)
-          else
-                stopstate='queue';
-          end
-        if isequal(stopstate,'queue')% enable STOP command
-            
-        %%%%%%%%%%%%%%%% loop on views (input lines) %%%%%%%%%%%%%%%%
-        for iview=1:nbview
-            % reading input file(s)
-            [Data{iview},tild,errormsg] = read_field(filecell{iview,index},FileType{iview},InputFields{iview},frame_index{iview}(index));
+% index_slice=i_slice:NbSlice:nbfield;% select file indices of the slice
+nbfiles=0;
+nbmissing=0;
+
+%%%%%%%%%%%%%%%% loop on field indices %%%%%%%%%%%%%%%%
+for index=1:nbfield
+%for index=index_slice
+      if checkrun
+            stopstate=get(Param.RUNHandle,'BusyAction');
+            update_waitbar(Param.WaitbarHandle,index/nbfield)
+      else
+            stopstate='queue';
+      end
+    if isequal(stopstate,'queue')% enable STOP command
+
+    %%%%%%%%%%%%%%%% loop on views (input lines) %%%%%%%%%%%%%%%%
+    for iview=1:nbview
+        % reading input file(s)
+        [Data{iview},tild,errormsg] = read_field(filecell{iview,index},FileType{iview},InputFields{iview},frame_index{iview}(index));
+        if ~isempty(errormsg)
+            errormsg=['error of input reading: ' errormsg];
+            break
+        end
+        if ~isempty(NbSlice_calib)
+            Data{iview}.ZIndex=mod(i1_series{iview}(index)-1,NbSlice_calib{iview})+1;%Zindex for phys transform
+        end
+    end
+    else
+        errormsg='stop';
+    end
+    %%%%%%%%%%%%%%%% end loop on views (input lines) %%%%%%%%%%%%%%%%
+    %%%%%%%%%%%% END STANDARD PART  %%%%%%%%%%%%
+    % EDIT FROM HERE
+
+    if isempty(errormsg)
+        Field=Data{1}; % default input field structure
+        %% coordinate transform (or other user defined transform)
+        if ~isempty(transform_fct)
+            switch nargin(transform_fct)
+                case 4
+                    if length(Data)==2
+                        Field=transform_fct(Data{1},XmlData{1},Data{2},XmlData{2});
+                    else
+                        Field=transform_fct(Data{1},XmlData{1});
+                    end
+                case 3
+                    if length(Data)==2
+                        Field=transform_fct(Data{1},XmlData{1},Data{2});
+                    else
+                        Field=transform_fct(Data{1},XmlData{1});
+                    end
+                case 2
+                    Field=transform_fct(Data{1},XmlData{1});
+                case 1
+                    Field=transform_fct(Data{1});
+            end
+        end
+
+        %% calculate tps coefficients if needed
+        if isfield(Param,'ProjObject')&&isfield(Param.ProjObject,'ProjMode')&& strcmp(Param.ProjObject.ProjMode,'interp_tps')
+            Field=tps_coeff_field(Field,check_proj_tps);
+        end
+
+        %field projection on an object
+        if Param.CheckObject
+            [Field,errormsg]=proj_field(Field,Param.ProjObject);
             if ~isempty(errormsg)
-                errormsg=['error of input reading: ' errormsg];
-                break
-            end
-            if ~isempty(NbSlice_calib)
-                Data{iview}.ZIndex=mod(i1_series{iview}(index)-1,NbSlice_calib{iview})+1;%Zindex for phys transform
-            end
-        end
-        else
-            errormsg='stop';
-        end
-        %%%%%%%%%%%%%%%% end loop on views (input lines) %%%%%%%%%%%%%%%%
-        %%%%%%%%%%%% END STANDARD PART  %%%%%%%%%%%%
-        % EDIT FROM HERE
-    
-        if isempty(errormsg)
-            Field=Data{1}; % default input field structure
-            %% coordinate transform (or other user defined transform)
-            if ~isempty(transform_fct)
-                switch nargin(transform_fct)
-                    case 4
-                        if length(Data)==2
-                            Field=transform_fct(Data{1},XmlData{1},Data{2},XmlData{2});
-                        else
-                            Field=transform_fct(Data{1},XmlData{1});
-                        end
-                    case 3
-                        if length(Data)==2
-                            Field=transform_fct(Data{1},XmlData{1},Data{2});
-                        else
-                            Field=transform_fct(Data{1},XmlData{1});
-                        end
-                    case 2
-                        Field=transform_fct(Data{1},XmlData{1});
-                    case 1
-                        Field=transform_fct(Data{1});
+                msgbox_uvmat('ERROR',['error in aver_stat/proj_field:' errormsg])
+                return
+            end
+        end
+        nbfiles=nbfiles+1;
+
+        %%%%%%%%%%%% MAIN RUNNING OPERATIONS  %%%%%%%%%%%%
+        %update sum
+        if nbfiles==1 %first field
+            time_1=[];
+            if isfield(Field,'Time')
+                time_1=Field.Time(1);
+            end
+            DataOut=Field;%default
+            for ivar=1:length(Field.ListVarName)
+                VarName=Field.ListVarName{ivar};
+                DataOut.(VarName)=double(DataOut.(VarName));
+            end
+        else   %current field
+            for ivar=1:length(Field.ListVarName)
+                VarName=Field.ListVarName{ivar};
+                sizmean=size(DataOut.(VarName));
+                siz=size(Field.(VarName));
+                if ~isequal(DataOut.(VarName),0)&& ~isequal(siz,sizmean)
+                    msgbox_uvmat('ERROR',['unequal size of input field ' VarName ', need to project  on a grid'])
+                    return
+                else
+                    DataOut.(VarName)=DataOut.(VarName)+ double(Field.(VarName)); % update the sum
                 end
             end
-            
-            %% calculate tps coefficients if needed
-            if isfield(Param,'ProjObject')&&isfield(Param.ProjObject,'ProjMode')&& strcmp(Param.ProjObject.ProjMode,'interp_tps')
-                Field=tps_coeff_field(Field,check_proj_tps);
-            end
-
-            %field projection on an object
-            if Param.CheckObject
-                [Field,errormsg]=proj_field(Field,Param.ProjObject);
-                if ~isempty(errormsg)
-                    msgbox_uvmat('ERROR',['error in aver_stat/proj_field:' errormsg])
-                    return
-                end
-            end
-            nbfiles=nbfiles+1;
-            
-            %%%%%%%%%%%% MAIN RUNNING OPERATIONS  %%%%%%%%%%%%
-            %update sum
-            if nbfiles==1 %first field
-                time_1=[];
-                if isfield(Field,'Time')
-                    time_1=Field.Time(1);
-                end
-                DataOut=Field;%default
-                for ivar=1:length(Field.ListVarName)
-                    VarName=Field.ListVarName{ivar};
-                    DataOut.(VarName)=double(DataOut.(VarName));
-                end
-            else   %current field
-                for ivar=1:length(Field.ListVarName)
-                    VarName=Field.ListVarName{ivar};
-                    sizmean=size(DataOut.(VarName));
-                    siz=size(Field.(VarName));
-                    if ~isequal(DataOut.(VarName),0)&& ~isequal(siz,sizmean)
-                        msgbox_uvmat('ERROR',['unequal size of input field ' VarName ', need to project  on a grid'])
-                        return
-                    else
-                        DataOut.(VarName)=DataOut.(VarName)+ double(Field.(VarName)); % update the sum
-                    end
-                end
-            end
-            %%%%%%%%%%%%   END MAIN RUNNING OPERATIONS  %%%%%%%%%%%%
-        else
-            display(errormsg)
-        end
-    end
-    %%%%%%%%%%%%%%%% end loop on field indices %%%%%%%%%%%%%%%%
-    
-    for ivar=1:length(Field.ListVarName)
-        VarName=Field.ListVarName{ivar};
-        DataOut.(VarName)=DataOut.(VarName)/nbfiles; % normalize the mean
-    end
-    if nbmissing~=0
-        msgbox_uvmat('WARNING',[num2str(nbmissing) ' input files are missing or skipted'])
-    end
-    if isempty(time) % time is read from files
-        if isfield(Field,'Time')
-            time_end=Field.Time(1);%last time read
-            if ~isempty(time_1)
-                DataOut.Time=time_1;
-                DataOut.Time_end=time_end;
-            end
-        end
-    else  % time from ImaDoc prevails if it exists
+        end
+        %%%%%%%%%%%%   END MAIN RUNNING OPERATIONS  %%%%%%%%%%%%
+    else
+        display(errormsg)
+    end
+end
+%%%%%%%%%%%%%%%% end loop on field indices %%%%%%%%%%%%%%%%
+
+for ivar=1:length(Field.ListVarName)
+    VarName=Field.ListVarName{ivar};
+    DataOut.(VarName)=DataOut.(VarName)/nbfiles; % normalize the mean
+end
+if nbmissing~=0
+    msgbox_uvmat('WARNING',[num2str(nbmissing) ' input files are missing or skipted'])
+end
+if isempty(time) % time is read from files
+    if isfield(Field,'Time')
+        time_end=Field.Time(1);%last time read
+        if ~isempty(time_1)
+            DataOut.Time=time_1;
+            DataOut.Time_end=time_end;
+        end
+    end
+else  % time from ImaDoc prevails if it exists
 %         j1=1;%default
 %         if ~isempty(j1_series{1})
 %             j1=j1_series{1};
 %         end
-        %DataOut.Time=time(1,i1_series{1}(1),j1);
-        %DataOut.Time_end=time(end,i1_series{end}(end),j1_series{end}(end));
-        DataOut.Time=time(1);
-        DataOut.Time_end=time(end);
-    end
-    
-    %writting the result file
-    OutputFile=fullfile_uvmat(RootPath{1},OutputDir,RootFile{1},FileExtOut,NomTypeOut,i1_series{1}(1),i1_series{1}(end),j1_series{1}(1),j1_series{1}(end));
-    if CheckImage{1} %case of images
-        if isequal(FileInfo{1}.BitDepth,16)||(numel(FileInfo)==2 &&isequal(FileInfo{2}.BitDepth,16))
-            DataOut.A=uint16(DataOut.A);
-            imwrite(DataOut.A,OutputFile,'BitDepth',16); % case of 16 bit images
-        else
-            DataOut.A=uint8(DataOut.A);
-            imwrite(DataOut.A,OutputFile,'BitDepth',8); % case of 16 bit images
-        end
+    %DataOut.Time=time(1,i1_series{1}(1),j1);
+    %DataOut.Time_end=time(end,i1_series{end}(end),j1_series{end}(end));
+    DataOut.Time=time(1);
+    DataOut.Time_end=time(end);
+end
+
+%writting the result file
+OutputFile=fullfile_uvmat(RootPath{1},OutputDir,RootFile{1},FileExtOut,NomTypeOut,i1_series{1}(1),i1_series{1}(end),j1_series{1}(1),j1_series{1}(end));
+if CheckImage{1} %case of images
+    if isequal(FileInfo{1}.BitDepth,16)||(numel(FileInfo)==2 &&isequal(FileInfo{2}.BitDepth,16))
+        DataOut.A=uint16(DataOut.A);
+        imwrite(DataOut.A,OutputFile,'BitDepth',16); % case of 16 bit images
+    else
+        DataOut.A=uint8(DataOut.A);
+        imwrite(DataOut.A,OutputFile,'BitDepth',8); % case of 16 bit images
+    end
+    display([OutputFile ' written']);
+else %case of netcdf input file , determine global attributes
+    errormsg=struct2nc(OutputFile,DataOut); %save result file
+    if isempty(errormsg)
         display([OutputFile ' written']);
-    else %case of netcdf input file , determine global attributes
-        errormsg=struct2nc(OutputFile,DataOut); %save result file
-        if isempty(errormsg)
-            display([OutputFile ' written']);
-        else
-            msgbox_uvmat('ERROR',['error in writting result file: ' errormsg])
-            display(errormsg)
-        end
-    end  % end averaging  loop
+    else
+        msgbox_uvmat('ERROR',['error in writting result file: ' errormsg])
+        display(errormsg)
+    end
+end  % end averaging  loop
 % end
 %%%%%%%%%%%%%%%% end loop on slices %%%%%%%%%%%%%%%%
